﻿Option Explicit On
Option Strict On

Imports iTextSharp
Imports iTextSharp.text
Imports iTextSharp.text.pdf

Imports System.Xml
Imports System.IO

'
' Crée par SharpDevelop.
' Utilisateur: Sebastien Leroux
' Date: 15/06/2011
' Heure: 11:10
'

Public Module TestModule
	
	Public Sub CreatingPieChartInPdfFromExcel(ByVal xmlFile As String)
		
		Try
			
			'Get the font
			Dim exePath As String = System.AppDomain.CurrentDomain.BaseDirectory
			
			Dim bf As BaseFont = BaseFont.CreateFont(exePath & "\lte50259.ttf", BaseFont.CP1252, BaseFont.EMBEDDED)
			
			'Chargement des information du xml
	        Dim xmlDoc As New XmlDocument
	        xmlDoc.Load(xmlFile)
	
			Dim nodeList As XmlNodeList
			nodeList = xmlDoc.GetElementsByTagName("pieChart")
	   		
	   		Dim mainNode As XmlNode
	   		mainNode = nodeList(0)
	   		
	   		Dim outputFile As String
	   		outputFile = mainNode.ChildNodes(0).InnerText
	 		
	 		Dim width, height, fontSize, separationWidth, radius As Single
	 		fontSize = CSng(mainNode.ChildNodes(1).InnerText)
	 		width = CSng(mainNode.ChildNodes(2).InnerText)
	 		height = CSng(mainNode.ChildNodes(3).InnerText)
	 		separationWidth = CSng(mainNode.ChildNodes(4).InnerText)
	 		
	 		radius = CSng( (2/3 * height) / 2 )
	 		
	 		Dim elements As XmlNodeList
	 		elements = mainNode.ChildNodes(5).ChildNodes
	 		
	 		'Création du pieChart
	 		Dim testPie As New DaaSeb.PdfReport.Charts.PieChart(width, height, radius)
	 		
	 		testPie.BaseFont = bf
	 		testPie.FontSize = fontSize
			testPie.SeparationWidth = separationWidth
	
			Dim el As XmlNode
	   		Dim name As String
	   		Dim weight As Single
	   		
	   		For Each el In elements
	   			name = el.ChildNodes(0).InnerText
	   			weight = CSng(el.ChildNodes(1).InnerText.Replace(CChar("."), System.Globalization.CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator))
	   			
	   			testPie.AddElement(name, weight)
	   		Next el
	
			testPie.IncludeBorder = False
			
			testPie.AddColor(229, 223, 208)
			testPie.AddColor(204, 176, 109)
			testPie.AddColor(166, 142, 91)
			testPie.AddColor(189, 172, 134)
			testPie.AddColor(137, 133, 124)
			testPie.AddColor(202, 198, 189)
			testPie.AddColor(204, 186, 119)
	
			testPie.ReorderElements()
			testPie.ConstructLegend()
	
	 		'Création du PDF
	 		Dim newDoc As New Document(PageSize.A4.Rotate())
			Dim writer As PdfWriter
			
			Try
				writer = PdfWriter.GetInstance(newDoc, New FileStream(outputFile, FileMode.Create))
				newDoc.Open()
			Catch ex As Exception
				Console.WriteLine("Error, file is probably already open")
				Console.WriteLine("Press any key to exit . . . ")
				Console.ReadKey(True)
				
				Exit Sub
			End Try
			
			Dim cb As PdfContentByte = writer.DirectContent
			
			Dim tp As PdfTemplate
			tp = testPie.getTemplate(cb)
			
			cb.AddTemplate(tp, newDoc.PageSize.Width/2 - width/2, newDoc.PageSize.Height/2 - height/2)
	 				
			newDoc.Close
			
			Process.Start(outputFile)
			
		Catch ex As Exception
			Console.WriteLine(ex.Message)
			Console.WriteLine("Press any key to exit . . . ")
			Console.ReadKey(True)
		End Try
		
	End Sub

End Module
